package com.robotlegs.examples.test02 
{
	import com.robotlegs.examples.test02.commands.SetUpAppCommand;
	import com.robotlegs.examples.test02.models.TestModel;

	import org.robotlegs.base.ContextEvent;
	import org.robotlegs.adapters.SwiftSuspendersInjector;
	import org.robotlegs.mvcs.Context;

	import flash.display.DisplayObjectContainer;

	/**
	 * @author Raúl Uranga
	 */
	public class MainContext extends Context 
	{
		private static const XML_SETUP:XML = <types>
								
									<type name='com.robotlegs.examples.test02.commands::SetUpAppCommand'>
						                <field name='model'/>
						            </type>
						            						            
						        </types>;

		public function MainContext(contextView:DisplayObjectContainer = null, autoStartup:Boolean = true)
		{
			injector = new SwiftSuspendersInjector(XML_SETUP);
			super(contextView, autoStartup);
			
			trace(XML_SETUP);
		}

		override public function startup():void 
		{
			trace("___startup__");
			
			commandMap.mapEvent(ContextEvent.STARTUP_COMPLETE, SetUpAppCommand, ContextEvent, true);
			
			injector.mapSingleton(TestModel);
			
			super.startup();
		}
	}
}
